## zipios++ 2.3.2

=== CMakeLists.txt ===
# Zipios -- a small C++ library that provides easy access to .zip files.
# Copyright (C) 2000-2007  Thomas Sondergaard
# Copyright (c) 2015-2022  Made to Order Software Corp.  All Rights Reserved
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

cmake_minimum_required(VERSION 3.10.2)

project(zipios_project)

option(RUN_TESTS "Enable CTest support and turn on the 'test' make target." OFF)
if(${RUN_TESTS})
    enable_testing()
endif()

# See `dev/version`
set( ZIPIOS_VERSION_MAJOR 2 )
set( ZIPIOS_VERSION_MINOR 3 )
set( ZIPIOS_VERSION_PATCH 2 )
set( ZIPIOS_VERSION_BUILD 0 )

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

if(MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNOMINMAX -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS")
    add_definitions(-DZIPIOS_WINDOWS)
else()
    if(BORLAND)
        message(FATAL_ERROR "Borland compiler not supported!")
    endif()

    # SUNOS is not set by cmake
    string(REGEX MATCH "SunOS" SUNOS ${CMAKE_SYSTEM_NAME})

    set(CMAKE_C_FLAGS           "${CMAKE_C_FLAGS} -fwrapv -fPIC"                                 )
    set(CMAKE_C_FLAGS_DEBUG     "${CMAKE_C_FLAGS_DEBUG} -Werror -Wall -Wextra -Wunused-parameter")
    set(CMAKE_C_FLAGS_RELEASE   "${CMAKE_C_FLAGS_RELEASE} -O3"                                   )
    #
    if(CYGWIN)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++17")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS_DEBUG} -g -O0 -fdiagnostics-show-option -Werror -Wall -Wextra -pedantic -Wcast-align -Wcast-qual -Wctor-dtor-privacy -Wdisabled-optimization -Winit-self -Wlogical-op -Wmissing-include-dirs -Woverloaded-virtual -Wredundant-decls -Wshadow -Wsign-promo -Wstrict-null-sentinel -Wstrict-overflow=4 -Wundef -Wno-unused -Wunused-variable -Wno-variadic-macros -Wno-parentheses -Wno-unknown-pragmas -Wwrite-strings -Wswitch -Wunused-parameter -Wfloat-equal -Wold-style-cast -Wnoexcept")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
endif()

option(BUILD_SHARED_LIBS "Build the ${PROJECT_NAME} libraries shared." ON)

if(BUILD_SHARED_LIBS)
    set(ZIPIOS_LIBRARY_TYPE SHARED)
else(BUILD_SHARED_LIBS)
    set(ZIPIOS_LIBRARY_TYPE STATIC)
endif(BUILD_SHARED_LIBS)

option(BUILD_DOCUMENTATION "Build the ${PROJECT_NAME} documentation." ON)

# To generate coverage, use -D<project name>_COVERAGE=ON
#                       and -DCMAKE_BUILD_TYPE=Debug
option(${PROJECT_NAME}_COVERAGE "Turn on coverage for ${PROJECT_NAME}." OFF)

if(${${PROJECT_NAME}_COVERAGE})
    if(MSVC)
        message(FATAL_ERROR "Coverage is not available on this platform (yet).")
    endif()

    message("*** COVERAGE TURNED ON ***")
    find_program(COV gcov)
    if(${COV} STREQUAL "COV-NOTFOUND")
        message(FATAL_ERROR "Coverage requested, but gcov not installed!")
    endif()
    if(NOT ${CMAKE_BUILD_TYPE} STREQUAL "Debug")
        message(FATAL_ERROR "Coverage requested, but Debug is not turned on! (i.e. -DCMAKE_BUILD_TYPE=Debug)")
    endif()
    #
    set(COV_C_FLAGS             "-fprofile-arcs -ftest-coverage")
    set(COV_CXX_FLAGS           "-fprofile-arcs -ftest-coverage")
    set(COV_SHARED_LINKER_FLAGS "-fprofile-arcs -ftest-coverage")
    set(COV_EXE_LINKER_FLAGS    "-fprofile-arcs -ftest-coverage")
    #
    set(CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} ${COV_C_FLAGS}"                        )
    set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} ${COV_CXX_FLAGS}"                    )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${COV_SHARED_LINKER_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} ${COV_EXE_LINKER_FLAGS}"      )
endif()

#
# Default install locations, override cache variables to change.
#
include(GNUInstallDirs)
set(BIN_INSTALL_DIR             ${CMAKE_INSTALL_BINDIR}             CACHE PATH "Location to install binaries relative to the install prefix."   )
set(INCLUDE_INSTALL_DIR         ${CMAKE_INSTALL_INCLUDEDIR}         CACHE PATH "Location to install headers relative to the install prefix."    )
set(LIB_INSTALL_DIR             ${CMAKE_INSTALL_LIBDIR}             CACHE PATH "Location to install libraries relative to the install prefix."  )
set(DATA_INSTALL_DIR            ${CMAKE_INSTALL_DATADIR}            CACHE PATH "Location to install data files relative to the install prefix." )
#set(CMAKE_MODULES_INSTALL_DIR   ${CMAKE_INSTALL_CMAKEMODULESDIR}    CACHE PATH "Location to install data files relative to the install prefix." )


find_package(ZLIB REQUIRED)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/zipios/zipios-config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/zipios/zipios-config.hpp )

# Generate the RPM package specification file
set(PACKAGE "libzipios")
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/contrib/zipios.spec.in ${CMAKE_CURRENT_BINARY_DIR}/contrib/zipios.spec )
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/contrib/zipios.metainfo.xml.in ${CMAKE_CURRENT_BINARY_DIR}/contrib/zipios.metainfo.xml )

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
)

add_subdirectory(cmake)
add_subdirectory(src  )
add_subdirectory(tools)
add_subdirectory(tests)
add_subdirectory(doc  )

install(
    DIRECTORY
        zipios

    DESTINATION
        ${INCLUDE_INSTALL_DIR}

    PATTERN
        "*.in" EXCLUDE
)

install(
    FILES
        ${CMAKE_BINARY_DIR}/zipios/zipios-config.hpp

    DESTINATION
        ${INCLUDE_INSTALL_DIR}/zipios
)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/contrib/zipios.metainfo.xml

        DESTINATION
            ${DATA_INSTALL_DIR}/metainfo
    )
endif()

# todo: how do we determine the correct destination?
#       (i.e. 3.x is now out and 2.8 will probably fail for those users)
#install( DIRECTORY cmake/
#    DESTINATION ${CMAKE_MODULES_INSTALL_DIR}
#)

add_custom_target(zipios_code_analysis
    # Make sure we have an output folder
    COMMAND mkdir -p ${PROJECT_BINARY_DIR}/analysis

    # Count the number of TODO, XXX, TBD, FIXME, and \todo
    COMMAND echo "TODO -- output ${PROJECT_BINARY_DIR}/analysis/todo.txt"
    COMMAND sh dev/todo.sh "${PROJECT_BINARY_DIR}/analysis"

    # Search for files with "invalid" (unwanted really) spaces
    COMMAND echo "Spaces -- output ${PROJECT_BINARY_DIR}/analysis/spaces.txt"
    COMMAND sh dev/spaces.sh "${PROJECT_BINARY_DIR}/analysis"

    # Boost inspect tool that reports various problems in the source
    # Note: I use `... || true` because inspect attempts an SVN check which
    #       obviously is going to fail here
    COMMAND echo "inspect -- output ${PROJECT_BINARY_DIR}/analysis/inspect.html"
    COMMAND inspect -tab -crlf -end -path_name -ascii -minmax -assert_macro -deprecated_macro -unnamed -copyright >"${PROJECT_BINARY_DIR}/analysis/inspect.html" || true

    # All of these are expected to work on source code so make sure we are
    # in the source code top directory
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
)

##
## To pack the source
##
set(CPACK_PACKAGE_NAME "zipios")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Zipios is a small C++ library for reading and writing zip files.")
set(CPACK_PACKAGE_VENDOR "Made to Order Software Corporation")
set(CPACK_PACKAGE_CONTACT "alexis@m2osw.com")
set(CPACK_RESOURCE_FILE_LICENSE "${zipios_project_SOURCE_DIR}/COPYING")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES "/CVS/;/work-files/;/.git/;.swp$;.*~;cscope.*;/tmp/;BUILD;Build")
set(CPACK_PACKAGE_VERSION "${ZIPIOS_VERSION_MAJOR}.${ZIPIOS_VERSION_MINOR}.${ZIPIOS_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${ZIPIOS_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${ZIPIOS_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${ZIPIOS_VERSION_PATCH}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "zipios-${ZIPIOS_VERSION_MAJOR}.${ZIPIOS_VERSION_MINOR}.${ZIPIOS_VERSION_PATCH}")
include(CPack)

# Local Variables:
# indent-tabs-mode: nil
# tab-width: 4
# End:

# vim: ts=4 sw=4 et nocindent

=== cmake/CMakeLists.txt ===
# Zipios -- a small C++ library that provides easy access to .zip files.
# Copyright (c) 2015-2022  Made to Order Software Corp.  All Rights Reserved
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

project(zipios2_cmake)

install(
    FILES
        ZipIosConfig.cmake

    DESTINATION
        share/cmake/ZipIos
)

# vim: ts=4 sw=4 et nocindent

=== doc/CMakeLists.txt ===
# Zipios -- a small C++ library that provides easy access to .zip files.
# Copyright (C) 2000-2007  Thomas Sondergaard
# Copyright (c) 2015-2022  Made to Order Software Corp.  All Rights Reserved
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

if(BUILD_DOCUMENTATION)

    project( zipios_documentation )

    ################################################################################
    # Copy of the AddDoxygenTarget from the Snap! C++ project
    # https://sourceforge.net/projects/snapcpp/
    #
    find_package(Doxygen QUIET)
    function(AddDoxygenTarget TARGET_NAME VERSION_MAJOR VERSION_MINOR VERSION_PATCH)
        cmake_parse_arguments(PARSE_ARGV 4 ADD_DOXY "QUIET" "" "")

        project(${TARGET_NAME}_Documentation)

        set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}")
        set(FULL_VERSION "${VERSION}.${VERSION_PATCH}")

        if(DOXYGEN_FOUND)
            if(NOT DOXYGEN_DOT_FOUND)
                message(WARNING "The dot executable was not found. Did you install Graphviz? No graphic output shall be generated in documentation.")
            endif()

            configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${TARGET_NAME}.doxy.in ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.doxy @ONLY)
            set(DOCUMENTATION_OUTPUT ${TARGET_NAME}-doc-${VERSION})

            if(SUNOS)
                set(TAR_OPTIONS cEzf)
            else()
                set(TAR_OPTIONS czf)
            endif()

            add_custom_command(
                OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${DOCUMENTATION_OUTPUT}.tar.gz ${DOCUMENTATION_OUTPUT}
                COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.doxy
                    1> ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}-doxy.log
                    2> ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}-doxy.err
                COMMAND echo Compacting as ${DOCUMENTATION_OUTPUT}.tar.gz
                COMMAND rm -rf ${DOCUMENTATION_OUTPUT}
                COMMAND mv html ${DOCUMENTATION_OUTPUT}
                COMMAND tar ${TAR_OPTIONS} ${DOCUMENTATION_OUTPUT}.tar.gz ${DOCUMENTATION_OUTPUT}
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )

            add_custom_target(${TARGET_NAME}_Documentation ALL
                DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${DOCUMENTATION_OUTPUT}.tar.gz
                COMMENT "Generating API documentation with Doxygen" VERBATIM
            )

            string(TOLOWER ${TARGET_NAME} LOWER_TARGET_NAME)
            install(
                DIRECTORY
                    ${CMAKE_CURRENT_BINARY_DIR}/${DOCUMENTATION_OUTPUT}/

                DESTINATION
                    ${DATA_INSTALL_DIR}/doc/${LOWER_TARGET_NAME}/html/
            )
            # The following installs the man3 files, we only install the man
            # pages of public classes. For more details the user will have to
            # go to the HTML documentation
            install(
                FILES
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_CollectionCollection.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_DirectoryCollection.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_DirectoryEntry.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_FileCollection.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_FileEntry.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_FilePath.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_VirtualSeeker.3
                   ${CMAKE_CURRENT_BINARY_DIR}/man/man3/zipios_ZipFile.3

                DESTINATION
                    ${DATA_INSTALL_DIR}/man/man3
            )
        else()
            if(NOT ADD_DOXY_QUIET)
                message( WARNING "You do not seem to have doxygen installed on this system, no documentation will be generated." )
            endif()
        endif()
    endfunction()

    configure_file(${CMAKE_SOURCE_DIR}/doc/zipios.doxy.in ${CMAKE_BINARY_DIR}/doc/zipios.doxy)

    AddDoxygenTarget(zipios ${ZIPIOS_VERSION_MAJOR} ${ZIPIOS_VERSION_MINOR} ${ZIPIOS_VERSION_PATCH} QUIET)

else(BUILD_DOCUMENTATION)

    message("No documentation will be created because you explicitly disabled it.")

endif(BUILD_DOCUMENTATION)

# Local Variables:
# indent-tabs-mode: nil
# tab-width: 4
# End:

# vim: ts=4 sw=4 et nocindent

=== src/CMakeLists.txt ===
# Zipios -- a small C++ library that provides easy access to .zip files.
# Copyright (C) 2000-2007  Thomas Sondergaard
# Copyright (c) 2015-2022  Made to Order Software Corp.  All Rights Reserved
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

project(zipios)

add_library(${PROJECT_NAME} ${ZIPIOS_LIBRARY_TYPE}
    backbuffer.cpp
    collectioncollection.cpp
    deflateoutputstreambuf.cpp
    directorycollection.cpp
    directoryentry.cpp
    dosdatetime.cpp
    filecollection.cpp
    fileentry.cpp
    filepath.cpp
    filterinputstreambuf.cpp
    filteroutputstreambuf.cpp
    gzipoutputstream.cpp
    gzipoutputstreambuf.cpp
    inflateinputstreambuf.cpp
    streamentry.cpp
    virtualseeker.cpp
    zipcentraldirectoryentry.cpp
    zipendofcentraldirectory.cpp
    zipfile.cpp
    zipinputstream.cpp
    zipinputstreambuf.cpp
    zipios_common.cpp
    ziplocalentry.cpp
    zipoutputstream.cpp
    zipoutputstreambuf.cpp
)

target_include_directories(${PROJECT_NAME}
    PUBLIC
        ${ZLIB_INCLUDE_DIR}
)

target_link_libraries(${PROJECT_NAME}
    ${ZLIB_LIBRARY}
)

set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION ${ZIPIOS_VERSION_MAJOR}.${ZIPIOS_VERSION_MINOR}
    SOVERSION ${ZIPIOS_VERSION_MAJOR}
)

install(
    TARGETS
        ${PROJECT_NAME}

    LIBRARY DESTINATION
        ${LIB_INSTALL_DIR}

    ARCHIVE DESTINATION
        ${LIB_INSTALL_DIR}

    RUNTIME DESTINATION
        ${BIN_INSTALL_DIR}
)


# Local Variables:
# indent-tabs-mode: nil
# tab-width: 4
# End:

# vim: ts=4 sw=4 et

=== tests/CMakeLists.txt ===
# Zipios -- a small C++ library that provides easy access to .zip files.
# Copyright (C) 2000-2007  Thomas Sondergaard
# Copyright (C) 2015-2022  Made to Order Software Corp.  All Rights Reserved
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

project(zipios_tests)

OPTION(BUILD_ZIPIOS_TESTS "Whether the zipios tests should be built. True by default." ON)

if(BUILD_ZIPIOS_TESTS)

    message("Tests are turned ON.")

    find_package(SnapCatch2)

    if(SNAPCATCH2_FOUND)

        add_executable(${PROJECT_NAME}
            catch_main.cpp

            catch_backbuffer.cpp
            catch_collectioncollection.cpp
            catch_common.cpp
            catch_directorycollection.cpp
            catch_directoryentry.cpp
            catch_dosdatetime.cpp
            catch_filepath.cpp
            catch_stream.cpp
            catch_version.cpp
            catch_virtualseeker.cpp
            catch_zipfile.cpp

            catch_directory_helper.cpp
            catch_raii_helpers.cpp
        )

        target_include_directories(${PROJECT_NAME}
            PUBLIC
                ${SNAPCATCH2_INCLUDE_DIRS}
        )

        target_link_libraries(${PROJECT_NAME}
            zipios
            ${SNAPCATCH2_LIBRARIES}
        )

        add_custom_target(run_zipios_tests
            # You can use the --success command line option to see all the tests
            # as they run; it is a LOT of output though, thus by default we don't
            # use it
            COMMAND ./zipios_tests
        )

        add_test(zipios_tests ${PROJECT_NAME})

    else(SNAPCATCH2_FOUND)

        message("No test will be created because you do not seem to have catch.hpp installed...")

        # For compatibility, just in case
        add_custom_target(run_zipios_tests
            COMMAND echo "No tests were built because it looks like you are missing Catch2."
        )

    endif(SNAPCATCH2_FOUND)

else(BUILD_ZIPIOS_TESTS)

    message("Tests are turned OFF. See BUILD_ZIPIOS_TESTS option.")

endif(BUILD_ZIPIOS_TESTS)

# vim: ts=4 sw=4 et

=== tools/CMakeLists.txt ===
# Zipios -- a small C++ library that provides easy access to .zip files.
# Copyright (C) 2000-2007  Thomas Sondergaard
# Copyright (c) 2015-2022  Made to Order Software Corp.  All Rights Reserved
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA


###
### ZipIOS Tool
###
project(zipios_tool)

add_executable(${PROJECT_NAME}
    zipios.cpp
)

set_target_properties(${PROJECT_NAME}
    PROPERTIES
        OUTPUT_NAME zipios
)

target_link_libraries(${PROJECT_NAME}
    zipios
)

install(
    TARGETS
        ${PROJECT_NAME}

    DESTINATION
        ${BIN_INSTALL_DIR}
)


###
### ZipDir Tool
###
project(zipdir)

add_executable(${PROJECT_NAME}
    zipdir.cpp
)

target_link_libraries(${PROJECT_NAME}
    zipios
)

install(
    TARGETS
        ${PROJECT_NAME}

    DESTINATION
        ${BIN_INSTALL_DIR}
)


###
### Append Zip Tool
###
project(appendzip)

add_executable(${PROJECT_NAME}
    appendzip.cpp
)

install(
    TARGETS
        ${PROJECT_NAME}

    DESTINATION
        ${BIN_INSTALL_DIR}
)



###
### DOS Date & Time Tool
###
project(dosdatetime)

add_executable(${PROJECT_NAME}
    dosdatetime.cpp
)

target_link_libraries(${PROJECT_NAME}
    zipios
)

install(
    TARGETS
        ${PROJECT_NAME}

    DESTINATION
        ${BIN_INSTALL_DIR}
)


###
### CRC32 Tool
###
project(zcrc32)

add_executable(${PROJECT_NAME}
    zcrc32.cpp
)

target_link_libraries(${PROJECT_NAME}
    ${ZLIB_LIBRARY}
)

install(
    TARGETS
        ${PROJECT_NAME}

    DESTINATION
        ${BIN_INSTALL_DIR}
)


###
### zipios_example.cpp
###
project(zipios_example)

add_executable(${PROJECT_NAME}
    zipios_example.cpp
)

target_link_libraries(${PROJECT_NAME}
    zipios
)

# DO NOT INSTALL THIS ONE, IT IS JUST AN EXAMPLE!
# BUT WE WANT TO MAKE SURE IT COMPILES.


# Local Variables:
# indent-tabs-mode: nil
# tab-width: 4
# End:

# vim: ts=4 sw=4 et

## zipios++ 0.1.5.9+cvs.2007.04.28

=== debian/changelog ===
zipios++ (0.1.5.9+cvs.2007.04.28-6) unstable; urgency=medium

  * QA upload, see #834214.
  * Use 3.0 (quilt) source format, use DEP3 quilt patches (Closes: #669703).
  * Use dh style debian/rules, hopefully (Closes: #794239).
  * This should also solve the FTBFS (Closes: #805963).
  * Add Homepage to debian/control (Closes: #834171).
  * DEP5ify debian/copyright.
  * Fix most lintians.

 -- W. Martin Borgert <debacle@debian.org>  Fri, 19 Aug 2016 13:00:30 +0000

zipios++ (0.1.5.9+cvs.2007.04.28-5.4) unstable; urgency=medium

  * Non-maintainer upload.

  [ Santiago Vila ]
  * Fix FTBFS when built with dpkg-buildpackage -A

 -- Anton Gladky <gladk@debian.org>  Fri, 12 Aug 2016 18:58:15 +0200

zipios++ (0.1.5.9+cvs.2007.04.28-5.3) unstable; urgency=low

  * Non-maintainer upload.
  * Bump debhelper compat from 4 to 9 (Closes: #817746).
  * Add build-{arch,indep} rules, fallback to build-stamp (Closes: #822040).

 -- W. Martin Borgert <debacle@debian.org>  Sat, 23 Jul 2016 18:09:45 +0000

zipios++ (0.1.5.9+cvs.2007.04.28-5.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Handle gcc5 transition by renaming library package to libzipios++0v5
    (Closes: #795212)
    - Thanks to Michael Terry for the report and the patch
  * Include dh-autoreconf to build properly on new architectures (Closes:
    #754833)
    - Thanks to Fernando Seiti Furusato for the report and the patch
  * Drop ancient conflicts/replaces that are no longer needed

 -- Scott Kitterman <scott@kitterman.com>  Sat, 22 Aug 2015 11:03:59 -0400

zipios++ (0.1.5.9+cvs.2007.04.28-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "zipios++: FTBFS: directory.h:85:12: error: 'ptrdiff_t' does not
    name a type": apply patch from Ubuntu / Julian Taylor:
    - debian/patches/03_ptrdiff.dpatch:
      include cstddef to fix build issue with gcc 4.6
    Closes: #625096
    LP: #832775

 -- gregor herrmann <gregoa@debian.org>  Sat, 08 Oct 2011 14:52:37 +0200

zipios++ (0.1.5.9+cvs.2007.04.28-5) unstable; urgency=low

  * Bumped to Standards-Version: 3.8.0.
  * Use DESTDIR instead of prefix for doc install, thanks Ben
    Hutchings - closes: #471338
  * Better handling of stream reading errors, thanks Fernando Diaz
    Alonso - closes: #395350

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Fri, 18 Jul 2008 00:44:54 +0900

zipios++ (0.1.5.9+cvs.2007.04.28-4) unstable; urgency=low

  * Added graphicsmagick-imagemagick-compat to Build-Depends.
    Thanks to Anibal Avelar - closes: #456349

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Wed, 02 Jan 2008 23:35:44 +0900

zipios++ (0.1.5.9+cvs.2007.04.28-3) unstable; urgency=low

  * Bumped to Standards-Version: 3.7.3.
  * Fixed various lintian warnings.
  * Now provides libzipios++-doc and manpages in libzipios++-dev 
    - closes: #288863

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Sun, 09 Dec 2007 06:33:47 +0900

zipios++ (0.1.5.9+cvs.2007.04.28-2) unstable; urgency=low

  * Fix for amd64 in -1 was incomplete.  Now fixed.
  * src/zipinputstreambuf.cpp : Backported from the previous revision. 
  The changes made in the upstream breaks enigma's score reading - closes: #421498

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Mon, 30 Apr 2007 10:21:50 +0900

zipios++ (0.1.5.9+cvs.2007.04.28-1) unstable; urgency=low

  * New upstream release (CVS snapshot).
  * Acknowledged NMU - closes: #372679
  * libzipios++-dev now depends on libz-dev - closes: #358721
  * Fixed build issue for forthcoming GCC 4.3 - closes: #417788
  * Fixed FSF's address.

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Sat, 28 Apr 2007 02:11:43 +0900

zipios++ (0.1.5.9+cvs.2004.02.07-3.4) unstable; urgency=high

  * Non-maintainer upload.
  * Ship an empty zipios-config.h, since it isn't good to have stuff like
    HAVE_ macros or (more importantly) PACKAGE and VERSION leak into other
    package's namespaces. Instead, the few #ifdefs in the headers that 
    actually used these macros have been resolved manually in the source,
    as they are consistent across all Debian systems and not likely to change
    in the near future. (Closes: #363173)

 -- Steinar H. Gunderson <sesse@debian.org>  Sun, 11 Jun 2006 00:46:57 +0200

zipios++ (0.1.5.9+cvs.2004.02.07-3.3) unstable; urgency=high

  * Non-maintainer upload.
  * Rename to libzipios++0c2a for libstdc++ allocator change (Closes: #339280).

 -- Luk Claes <luk@debian.org>  Mon,  2 Jan 2006 19:26:45 +0100

zipios++ (0.1.5.9+cvs.2004.02.07-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build depend on libcppunit-dev. (Closes: #288819).

 -- Luk Claes <luk@debian.org>  Mon, 17 Oct 2005 17:56:52 +0200

zipios++ (0.1.5.9+cvs.2004.02.07-3.1) unstable; urgency=low

  * NMU
  * gcc4 transition, renamed libzipios++0c102 to libzipios++0,
    not waiting for cppunit to be transitioned, since the tests built
    with it are not shipped nor executed at build-time.
  * Fix crash in amd64, closes: #314602

 -- Isaac Clerencia <isaac@debian.org>  Mon, 18 Jul 2005 23:50:27 +0200

zipios++ (0.1.5.9+cvs.2004.02.07-3) unstable; urgency=low

  * Added missing zipios-config.h - closes: #232097

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Wed, 11 Feb 2004 08:59:21 +0900

zipios++ (0.1.5.9+cvs.2004.02.07-2) unstable; urgency=low

  * [control] changed Maintainer field.

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Sun,  8 Feb 2004 01:28:47 +0900

zipios++ (0.1.5.9+cvs.2004.02.07-1) unstable; urgency=low

  * New upstream release (CVS snapshot).
  * Bumped Standards-Version to 3.6.1.

 -- Masayuki Hatta (mhatta) <mhatta@debian.org>  Sat,  7 Feb 2004 16:47:39 +0900

zipios++ (0.1.5+cvs.2003.03.18-1) unstable; urgency=low

  * New upstream release (CVS snapshot).
  * Added Build-Depends: automake1.7 - closes: #178638

 -- Masayuki Hatta <mhatta@debian.org>  Tue, 18 Mar 2003 10:51:25 +0900

zipios++ (0.1.5+cvs.2003.01.14-1) unstable; urgency=low

  * New upstream release (CVS snapshot).


=== debian/control ===
Source: zipios++
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: automake | automaken, autotools-dev, dh-autoreconf, debhelper (>> 9), doxygen, graphicsmagick-imagemagick-compat | imagemagick, libcppunit-dev, libz-dev
Standards-Version: 3.9.8
Homepage: http://zipios.sourceforge.net/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/zipios++.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/zipios++.git

Package: libzipios++-dev
Section: libdevel
Architecture: any
Depends: libzipios++0v5 (= ${binary:Version}), libz-dev, ${misc:Depends}
Description: small C++ library for reading zip files (development)
 Zipios++ is a java.util.zip-like C++ library for reading and writing Zip
 files. Access to individual entries is provided through standard C++
 iostreams. A simple read-only virtual file system that mounts regular
 directories and zip files is also provided.
 .
 This package contains files needed for development with zipios++.

Package: libzipios++0v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libzipios++0c2a
Replaces: libzipios++0c2a
Description: small C++ library for reading zip files (library)
 Zipios++ is a java.util.zip-like C++ library for reading and writing Zip
 files. Access to individual entries is provided through standard C++
 iostreams. A simple read-only virtual file system that mounts regular
 directories and zip files is also provided.
 .
 This package contains shared library.

Package: libzipios++-doc
Section: doc
Architecture: all
Suggests: libzipios++-dev
Depends: ${misc:Depends}, libjs-jquery
Description: small C++ library for reading zip files (documents)
 Zipios++ is a java.util.zip-like C++ library for reading and writing Zip
 files. Access to individual entries is provided through standard C++
 iostreams. A simple read-only virtual file system that mounts regular
 directories and zip files is also provided.
 .
 This package contains documentations for development with zipios++.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

%:
	dh $@ --with autotools-dev

override_dh_auto_build-indep:
	$(MAKE) doc

override_dh_auto_test:
	# not ready yet

## zipios++ 0.1.7

=== debian/changelog ===
zipios++ (0.1.7-3) unstable; urgency=medium

  [ Tobias Frost ]
  * Team Upload.
  * Update S-V to 4.7.2:
    - replace http:// with https:// (e.g d/copyright Format field)
  * Switch to debhelper-compat.
  * Fix doc-base registration. 
  * Drop uneeded B-D on autotools-dev, dh-autoreconf.

  [ James Lu ]
  * Remove B-D: graphicsmagick-imagemagick-compat alternative.
    Closes: #1120164

 -- Tobias Frost <tobi@debian.org>  Sun, 14 Dec 2025 13:48:34 +0100

zipios++ (0.1.7-2) unstable; urgency=medium

  * Team upload.
  * Install backbuffer.h and zipios_common.h to the development package.

 -- Tobias Frost <tobi@debian.org>  Sat, 21 Dec 2024 17:42:08 +0100

zipios++ (0.1.7-1) unstable; urgency=medium

  * Team upload. 
  * New upstream release of the old API.
  * Remove patches applied upstream and refresh one. 
  * d/docs: s/README/README.md 
  * Fix superfluous call of getNextEntry() inside ZipFile::getInputStream,
    as this breaks zipios e.g for freecad 1.0 (Closes: #1089837)
  * Don't install broken manpages
  * Drop d/dirs. 
  * B-D on pkgconf instead of pkg-config. 
  * Point VCS-* to salsa.d.o. (Repository layout is now DEP-14)

 -- Tobias Frost <tobi@debian.org>  Sat, 21 Dec 2024 15:27:23 +0100

zipios++ (0.1.5.9+cvs.2007.04.28-11) unstable; urgency=high

  * New Maintainer (Closes: #834214)
  * fix CVE-2019-13453 (Closes: #932556)

 -- Francois Mazen <francois@mzf.fr>  Sat, 05 Oct 2019 13:57:39 +0200

zipios++ (0.1.5.9+cvs.2007.04.28-10) unstable; urgency=medium

  * QA upload.
  * upload to unstable

 -- Rene Engelhard <rene@debian.org>  Sun, 28 May 2017 19:20:05 +0000

zipios++ (0.1.5.9+cvs.2007.04.28-9) experimental; urgency=medium

  * QA upload.
  * *really* add pkg-config build-dependency... 

 -- Rene Engelhard <rene@debian.org>  Tue, 09 May 2017 07:29:01 +0200

zipios++ (0.1.5.9+cvs.2007.04.28-8) experimental; urgency=medium

  * QA upload.
  * add pkg-config build-dependency... 

 -- Rene Engelhard <rene@debian.org>  Tue, 09 May 2017 07:11:50 +0200

zipios++ (0.1.5.9+cvs.2007.04.28-7) experimental; urgency=medium

  * QA upload.
  * use pkg-config, not cppunit-config (closes: #862126) 
  * use --with autoreconf instead of --with autotools-dev to regen
    for above 

 -- Rene Engelhard <rene@debian.org>  Mon, 08 May 2017 22:29:06 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: zipios++
 Section: devel
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends: automake | automaken, autotools-dev, dh-autoreconf, debhelper (>> 9), doxygen, graphicsmagick-imagemagick-compat | imagemagick, libcppunit-dev, libz-dev
-Standards-Version: 3.9.8
-Homepage: http://zipios.sourceforge.net/
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/zipios++.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/zipios++.git
+Maintainer: Francois Mazen <francois@mzf.fr>
+Build-Depends: automake | automaken, debhelper, debhelper-compat (= 13), doxygen, imagemagick, libcppunit-dev (>= 1.12), libz-dev, pkgconf
+Standards-Version: 4.7.2
+Homepage: https://zipios.sourceforge.net/
+Vcs-Browser: https://salsa.debian.org/debian/zipios
+Vcs-Git: https://salsa.debian.org/debian/zipios.git
 
 Package: libzipios++-dev
 Section: libdevel

## zipios++ 2.3.2

=== debian/changelog ===
zipios++ (2.3.2-1) experimental; urgency=high

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + libzipios++-doc: Add Multi-Arch: foreign.
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Submit, Repository.

  [ Francois Mazen ]
  * New upstream version.
  * Update standards version to 4.6.2, no changes needed.
  * Fix FTBFS with recent jdupes (Closes: #1042829)

 -- Francois Mazen <mzf@debian.org>  Sat, 30 Dec 2023 09:34:38 +0100

zipios++ (2.2.6-1) experimental; urgency=high

  * Import new upstream release (Closes: #834171).
  * Rename packages:
     - libzipios++0v5 => libzipios2
     - libzipios++-dev => libzipios-dev
     - libzipios++-doc => libzipios-doc
  * Create libzipios++-doc transitional package
  * Add watch file
  * Add autopkgtest
  * Add upstream metadata
  * Bump standard version to 4.5.0
     - Rules-Requires-Root: no
  * Remove documentation duplicate files
  * Update debhelper compatibility to 13 and ignore uninstalled test binaries.
  * Move doxygen and graphviz dependency to Build-Depends-Indep
  * Remove doxygen jquery symlink (see /usr/share/doc/doxygen/README.jquery)
  * Drop unused libjs-jquery dependency.
  * Dev package suggests doc package
  * Do not build tools that are not part of any package
  * Fix indep build (from Tobias Frost)
  * Remove unneeded file d/dirs (from Tobias Frost)

 -- Francois Mazen <francois@mzf.fr>  Sat, 07 Mar 2020 15:08:28 +0100

=== debian/control ===
Source: zipios++
Section: devel
Priority: optional
Maintainer: Francois Mazen <mzf@debian.org>
Build-Depends: cmake,
               catch,
               debhelper,
               debhelper-compat (= 13),
               jdupes,
               libz-dev,
               zip
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.6.2
Homepage: https://zipios.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/debian/zipios
Vcs-Git: https://salsa.debian.org/debian/zipios.git
Rules-Requires-Root: no

Package: libzipios-dev
Section: libdevel
Architecture: any
Depends: libzipios2 (= ${binary:Version}), libz-dev, ${misc:Depends}
Breaks: libzipios++-dev (<< 2.0.0)
Replaces: libzipios++-dev (<< 2.0.0)
Suggests: libzipios-doc
Description: small C++ library for reading zip files (development)
 Zipios++ is a java.util.zip-like C++ library for reading and writing Zip
 files. Access to individual entries is provided through standard C++
 iostreams. A simple read-only virtual file system that mounts regular
 directories and zip files is also provided.
 .
 This package contains files needed for development with zipios++.

Package: libzipios2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: small C++ library for reading zip files (library)
 Zipios++ is a java.util.zip-like C++ library for reading and writing Zip
 files. Access to individual entries is provided through standard C++
 iostreams. A simple read-only virtual file system that mounts regular
 directories and zip files is also provided.
 .
 This package contains shared library.

Package: libzipios-doc
Section: doc
Architecture: all
Suggests: libzipios-dev
Depends: ${misc:Depends}
Breaks: libzipios++-doc (<< 2.0.0)
Replaces: libzipios++-doc (<< 2.0.0)
Description: small C++ library for reading zip files (documents)
 Zipios++ is a java.util.zip-like C++ library for reading and writing Zip
 files. Access to individual entries is provided through standard C++
 iostreams. A simple read-only virtual file system that mounts regular
 directories and zip files is also provided.
 .
 This package contains documentations for development with zipios++.

Package: libzipios++-doc
Depends: libzipios-doc, ${misc:Depends}
Architecture: all
Section: oldlibs
Multi-Arch: foreign
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- -DRUN_TESTS=ON

override_dh_auto_build-indep:
	cd obj-$${DEB_HOST_GNU_TYPE} && $(MAKE) zipios_Documentation

override_dh_auto_install-indep:
	mkdir -p debian/tmp/usr/share/doc/zipios/html
	cp -r obj-$${DEB_HOST_GNU_TYPE}/doc/zipios-doc-*/* debian/tmp/usr/share/doc/zipios/html/

override_dh_installdocs-indep:
	dh_installdocs -i
	dh_doxygen

execute_after_dh_link-indep:
	dh_link
	jdupes -rl debian/libzipios-doc/usr/share/doc

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/tests/control ===
Tests: build-and-run
Depends: libzipios-dev, build-essential, zip

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/zipios++-$1\.tar\.gz/ \
  https://github.com/zipios/zipios/tags .*/v?(\d\S+)\.tar\.gz
